QGIS Application - Bug report #9523
openProject macro won't load when enable Macros setting set to Ask
2014-02-10 01:49 AM - Heather Hillers

Status: Closed

Priority: High

Assignee:

Category: Python plugins

Affected QGIS version:2.18.11 Regression?: Yes

Operating System: Easy fix?: No

Pull Request or Patch supplied: Resolution: fixed/implemented
Crashes QGIS or corrupls data: Copied to github as #: 18113
Description

Hello,

If I have a Project with a Macro as shown below, and | set Settings->Options->Enable Macros to "Ask", the openProject macro will never
load. If | set Enable Macros to Always, or only for this session, it will load.

In Ask mode:

| open the Project.

| get the security warning in the canvas view.

I click "Enable Macros"

The security warning disappears

The Project loads without the "Hello | am a Macro" Status bar.

In Always or Only this session:

| open the Project
| see the "Hello | am a Macro" Status bar.

If I run the code as a saveProject macro, then the saveProject macro will work for the Ask Setting. So, the Problem is just with
openProject.

def openProject():
from qgis.utils import iface
from qgis.gui import QgsMessageBar
iface.messageBar().pushMessage("Hello | am a Macro", ", level=QgsMessageBar.INFO)

def saveProject():
pass

def closeProject():
pass

This is the case for QGIS 2.0.1 as well as today's dev Version Qgis 2.1.0 f06e72e, on Windows as well as on Ubuntu.

Associated revisions

Revision fa366390 - 2016-10-31 06:22 AM - Nyall Dawson
Fix 'enable macros' button does not run open macro (fix #9523)

History

#1 - 2014-02-11 12:52 AM - Salvatore Larosa
- Category set to Python plugins
- Target version set to Version 2.2

#2 - 2014-02-11 12:53 AM - Salvatore Larosa
- Pull Request or Patch supplied changed from No to Yes

See https://github.com/qgis/QGIS/pull/1159

#3 - 2014-02-24 05:49 AM - Heather Hillers

Thanks.

#4 - 2014-06-28 07:36 AM - Jiirgen Fischer

- Target version changed from Version 2.2 to Future Release - Lower Priority

#5 - 2016-10-30 10:22 PM - Nyall Dawson
- Status changed from Open to Closed

Fixed in changeset commit:"fa3663907a706971bbc418a1896b48a14f572327".

#6 - 2017-07-05 05:01 PM - Andreas Neumann

- Affected QGIS version changed from master to 2.18.10
- Description updated

- Status changed from Closed to Open

Reopening this bug, because there is a regression in 2.18.10

Same behavior as stated. The macro does not run if enabled after asking the user.

Tested on Windows 7, 64bit.

#7 - 2017-07-05 05:05 PM - Andreas Neumann

openProject macros run fine if set to "Always run", not after enabling with "Ask"

#8 - 2017-07-05 05:12 PM - Andreas Neumann

- Pull Request or Patch supplied changed from Yes to No

- Regression? changed from No to Yes

#9 - 2017-07-06 02:29 PM - Giovanni Manghi
https://github.com/qgis/QGIS/pull/1159

- Priority changed from Normal to High

#10 - 2017-07-07 01:18 AM - Nyall Dawson

- Status changed from Open to Feedback

Andreas - is this a new issue? Or are you reopening because you want a fix in 2.18?

#11 - 2017-07-07 07:35 AM - Andreas Neumann

Hi Nyall,

| think a fix for 2.18 would be useful. 2.18 will be around for at least 2 years until people have all their favourite plugins ported to 3.x - so it makes sense to
still provide 2.18 fixes for at least another year.

Apparently this issue (or a very similar issue) was fixed by you 8 months ago. | don't know what happened in between and why it doesn't work anymore).

The workaround to always enable project macros is a bad security practice.

Thanks,

Andreas

#12 - 2017-07-07 08:59 AM - Nyall Dawson

My fix was only for the 3.0 branch - it relies on a feature not available in the Qt4 builds. It'd need to be reworked to be backportable.

#13 - 2017-07-25 07:44 PM - Giovanni Manghi

- Affected QGIS version changed from 2.18.10 to 2.18.11

#14 - 2017-09-25 04:22 PM - Giovanni Manghi
- Status changed from Feedback to Open

#15 - 2019-01-26 07:50 AM - Alexander Bruy

- Status changed from Open to Feedback

Should we close this now, as QGIS 2.18 has reached its end of life?

#16 - 2019-01-26 11:37 AM - Nyall Dawson
- Status changed from Feedback to Closed
- Resolution set to fixed/implemented
